package REAPI;



import java.io.ByteArrayOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.logging.Level;

import org.eclipse.birt.core.framework.Platform;
import org.eclipse.birt.report.engine.api.EngineConfig;
import org.eclipse.birt.report.engine.api.EngineException;
import org.eclipse.birt.report.engine.api.IRenderTask;
import org.eclipse.birt.report.engine.api.IReportDocument;
import org.eclipse.birt.report.engine.api.IReportEngine;
import org.eclipse.birt.report.engine.api.IReportEngineFactory;
import org.eclipse.birt.report.engine.api.IReportRunnable;
import org.eclipse.birt.report.engine.api.IRunTask;
import org.eclipse.birt.report.engine.api.PDFRenderOption;

import com.lowagie.text.Chunk;
import com.lowagie.text.DocumentException;
import com.lowagie.text.Paragraph;
import com.lowagie.text.Phrase;
import com.lowagie.text.Rectangle;
import com.lowagie.text.pdf.ColumnText;
import com.lowagie.text.pdf.PdfAction;
import com.lowagie.text.pdf.PdfArray;
import com.lowagie.text.pdf.PdfDestination;
import com.lowagie.text.pdf.PdfDictionary;
import com.lowagie.text.pdf.PdfOutline;
import com.lowagie.text.pdf.PdfPCell;
import com.lowagie.text.pdf.PdfPTable;
import com.lowagie.text.pdf.PdfReader;
import com.lowagie.text.pdf.PdfStamper;
import com.lowagie.text.pdf.PdfWriter;
import com.lowagie.text.pdf.SimpleBookmark;
import com.lowagie.text.pdf.SimpleNamedDestination;


public class GenerateFirstPageTocPDF {

	public void insertPages(PdfReader reader, PdfStamper stamper, Rectangle rect){

		List<HashMap<String, Object>> list = SimpleBookmark.getBookmark(reader);
		int ii=0;
		int pg=1;
		for (HashMap<String, Object> bookmark : list) {
			ii++;
			if( ii > 40){
				pg = pg+1;
				stamper.insertPage(pg, rect);
				ii=0;
			}
			List<HashMap<String, Object>> clist = (List) bookmark.get("Kids");
			for (HashMap<String, Object> chlist : clist) {
				ii++;
				if( ii > 40){
					pg = pg+1;
					stamper.insertPage(pg, rect);
					ii=0;
				}
			}


		}

	}
	public void tst(ByteArrayOutputStream baos, String outpath){

		try {
			PdfReader reader = new PdfReader(baos.toByteArray());


			PdfDictionary pdfd = reader.getCatalog();
			//ArrayList tst5 = reader.getLinks(0);
			//PdfContentByte.getRootOutline()			
			HashMap hm =reader.getInfo();
			HashMap hm2 =reader.getNamedDestination();



			Rectangle rect = reader.getPageSizeWithRotation(1);
			PdfStamper stamper = new PdfStamper(reader, new FileOutputStream(outpath));
			stamper.setViewerPreferences(PdfWriter.PageModeUseOutlines);
			stamper.insertPage(1, rect);

			ColumnText column = new ColumnText(stamper.getOverContent(1));
			column.setSimpleColumn(rect.getLeft(36), rect.getBottom(36),
					rect.getRight(36), rect.getTop(36));




			column.addElement(new Paragraph("TABLE OF CONTENTS"));

			insertPages(reader, stamper, rect);
			HashMap hm3 = SimpleNamedDestination.getNamedDestination(reader, false);
			List<HashMap<String, Object>> list = SimpleBookmark.getBookmark(reader);
			//SimpleBookmark.exportToXML(arg0, arg1, arg2, arg3)

			int tt = reader.getNumberOfPages();
			SimpleBookmark.shiftPageNumbers(list, reader.getNumberOfPages(), null);


			PdfPTable table = new PdfPTable(1);
			PdfPCell cell = null;
			int ii=0;
			int pg=1;
			Chunk link;
			PdfAction action;
			String info;
			int p = 1;
			float y = 10;
			for (HashMap<String, Object> bookmark : list) {
				link = new Chunk((String)bookmark.get("Title"));
				info = (String) bookmark.get("Page");
				if( info != null ){
					p = Integer.parseInt(info.substring(0, info.indexOf(' ')));
					y = Float.parseFloat(info.substring(info.lastIndexOf(' ') + 1) + "f");
					action = PdfAction.gotoLocalPage(p, new PdfDestination(
							PdfDestination.FITH, y), stamper.getWriter());
					link.setAction(action);

				}else{

					action =PdfAction.gotoLocalPage((String) bookmark.get("Title"), false);
					link.setAction(action);					
				}
				cell = new PdfPCell(new Paragraph(link));
				cell.setBorder(PdfPCell.NO_BORDER);
				table.addCell(cell);
				ii++;
				if( ii > 40){
					pg = pg+1;
					//stamper.insertPage(pg, rect);
					column.addElement(table);
					column.go();
					column = new ColumnText(stamper.getOverContent(pg));
					column.setSimpleColumn(rect.getLeft(36), rect.getBottom(36),
							rect.getRight(36), rect.getTop(36));
					table = new PdfPTable(1);
					p = 1;
					y = 10;
					ii=0;
				}

				List<HashMap<String, Object>> clist = (List) bookmark.get("Kids");
				System.out.println(clist.size());

				for (HashMap<String, Object> chlist : clist) {
					link = new Chunk((String)chlist.get("Title"));
					info = (String) chlist.get("Page");
					if( info != null ){
						p = Integer.parseInt(info.substring(0, info.indexOf(' ')));
						y = Float.parseFloat(info.substring(info.lastIndexOf(' ') + 1) + "f");
						action = PdfAction.gotoLocalPage(p, new PdfDestination(
								PdfDestination.FITH, y), stamper.getWriter());
						link.setAction(action);

					}else{
						action =PdfAction.gotoLocalPage((String) chlist.get("Title"), false);
						link.setAction(action);					
					}
					PdfArray pda = (PdfArray) hm2.get((String) chlist.get("Title"));
					int ln =pda.length();
					String ss = pda.toString();
					String sss = (String) hm3.get((String) chlist.get("Title"));
					String[] pga =sss.split(" ");
					Phrase ph = new Phrase("	");
					ph.add(new Chunk(link));
					ph.add(new Chunk("............................................................" + pga[0]) );
					;
					cell = new PdfPCell(ph);
					cell.setBorder(PdfPCell.NO_BORDER);
					table.addCell(cell);
					ii++;
					if( ii > 40){
						pg = pg+1;
						//stamper.insertPage(pg, rect);
						column.addElement(table);
						column.go();
						column = new ColumnText(stamper.getOverContent(pg));
						column.setSimpleColumn(rect.getLeft(36), rect.getBottom(36),
								rect.getRight(36), rect.getTop(36));
						table = new PdfPTable(1);
						p = 1;
						y = 10;
						ii=0;
					}

				}




			}
			column.addElement(table);
			column.go();
			PdfOutline pdfo = stamper.getWriter().getRootOutline();
			stamper.close();
			reader.close();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (DocumentException e) {
			e.printStackTrace();
		}

	}


	public void runReport() throws EngineException
	{

		IReportEngine engine=null;
		EngineConfig config = null;

		try{

			config = new EngineConfig( );			
			config.setBIRTHome("C:\\birt\\birt-runtime-2_6_1\\birt-runtime-2_6_1\\ReportEngine");
			config.setLogConfig(null, Level.OFF);
			Platform.startup( config );
			IReportEngineFactory factory = (IReportEngineFactory) Platform
			.createFactoryObject( IReportEngineFactory.EXTENSION_REPORT_ENGINE_FACTORY );
			engine = factory.createReportEngine( config );
		}catch( Exception ex){
			ex.printStackTrace();
		}

		IReportRunnable design, design2 = null;
		//Open the report design
		design = engine.openReportDesign("Reports/TOC.rptdesign"); 

		//Create task to run and render the report,
		IRunTask task = engine.createRunTask(design); 
		task.run("output/resample/toc.rptdocument");
		task.close();

		IReportDocument document = null;
		//Open the report design
		document = engine.openReportDocument("output/resample/toc.rptdocument"); 

		IRenderTask rtask = engine.createRenderTask(document); 

		PDFRenderOption options = new PDFRenderOption();
		ByteArrayOutputStream fso= new ByteArrayOutputStream();
		options.setOutputStream(fso);
		//options.setOutputFileName("c:/test5/jj.pdf");
		options.setOutputFormat("pdf");

		rtask.setRenderOption(options);
		rtask.render();
		rtask.close();
		tst(fso, "c:/test/final.pdf");
		//createToc(fso, "c:/test5/what2.pdf");

		engine.destroy();
		Platform.shutdown();
		System.out.println("Finished");
	}	


	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try
		{

			GenerateFirstPageTocPDF ex = new GenerateFirstPageTocPDF( );
			ex.runReport();

		}
		catch ( Exception e )
		{
			e.printStackTrace();
		}
	}



}


